package de.fhmuenster.masterthesis.serialization;

import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import de.fhmuenster.masterthesis.testgeneratorDSL.BPMNDiagram;
import de.fhmuenster.masterthesis.testgeneratorDSL.Flow;
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElement;

public class Main {

	public static void main(String[] args) throws IOException {
		
		doFirst();
//		doSecond();
//		doThird();
//		doFourth();
	}
	
	private static void doFirst() throws IOException {
		TestgeneratorDSLSerializer serialize = new TestgeneratorDSLSerializer("C:\\Users\\Leon\\Desktop\\Test123.bpmn-testgen");
		
		BPMNDiagram bpmnDiagram = TestgeneratorDSLObjectCreator.createBPMNDiagram(
				"process", //
				"de.fhmuenster.masterthesis.demoproject.masterthesissimpledemo", //
				"process.bpmn", //
				"MasterthesisSimpleDemo", //
				Arrays.asList("decision.dmn"),
				Arrays.asList("wup.html")); //
		
		FlowElement start = TestgeneratorDSLObjectCreator.createStartFlowElement("Start_123", Arrays.asList());
		FlowElement gateway = TestgeneratorDSLObjectCreator.createGatewayFlowElement("Gateway_123");
		FlowElement activity = TestgeneratorDSLObjectCreator.createUserTaskFlowElement("Activity_123", Arrays.asList(), Arrays.asList(), "Activity 123", null);
		FlowElement end = TestgeneratorDSLObjectCreator.createEndFlowElement("End_123");
		FlowElement activity2 = TestgeneratorDSLObjectCreator.createServiceTaskFlowElement("Activity_234");
		FlowElement end2 = TestgeneratorDSLObjectCreator.createEndFlowElement("End_234");
		
		Flow flow1 = TestgeneratorDSLObjectCreator.createFlow(//
				"Flow_1", //
				bpmnDiagram, //
				Arrays.asList(start, gateway, activity, end), // 
				Arrays.asList(activity2, end2)); //
		
		serialize.addBPMNDiagram(bpmnDiagram);
		serialize.addFlowElement(start);
		serialize.addFlowElement(gateway);
		serialize.addFlowElement(activity);
		serialize.addFlowElement(end);
		serialize.addFlowElement(activity2);
		serialize.addFlowElement(end2);
		serialize.addFlow(flow1);
		
		serialize.serialize();
	}
	
	private static void doSecond() throws IOException {
		TestgeneratorDSLSerializer serialize = new TestgeneratorDSLSerializer("C:\\Users\\Leon\\Desktop\\Test123.bpmn-testgen");

		BPMNDiagram bpmnDiagram = serialize.getBPMNDiagram("process");
		List<FlowElement> inclElements = serialize.getFlowElements(Arrays.asList("Start_123", "Gateway", "Activity_234", "End_234"));
		List<FlowElement> exclElements = serialize.getFlowElements(Arrays.asList("Activity_123", "End_123"));
		
		Flow flow2 = TestgeneratorDSLObjectCreator.createFlow(//
				"Flow_2", //
				bpmnDiagram, //
				inclElements, // 
				exclElements); //
		
		serialize.addFlow(flow2);
		
		serialize.serialize();
	}
	
	private static void doThird() throws IOException {
		TestgeneratorDSLSerializer serialize = new TestgeneratorDSLSerializer("C:\\Users\\Leon\\Desktop\\Test123.bpmn-testgen");
		serialize.getFlowElements().forEach(e -> System.out.println(e.getName()));
	}
	
	private static void doFourth() throws IOException {
		TestgeneratorDSLSerializer serialize = new TestgeneratorDSLSerializer("C:\\Users\\Leon\\Desktop\\Test123.bpmn-testgen");

		FlowElement start3 = TestgeneratorDSLObjectCreator.createStartFlowElement("Start_789", Arrays.asList());
		serialize.addFlowElement(start3);
		
		serialize.serialize();
	}
}
